program BacktrackQueens;
uses Dos;

var
n : integer; { ###### ##### }
queen : array[1..100] of integer; { ###### ######### ###### }

{ ######### ###### ####### }
procedure WriteSolution;
var
    i : integer;
begin
    for i := 1 to n do
        Write(queen[i],' ');
    WriteLn;
end;

{ ####### ######## ############# m## ##### # ########### }
function Check(m : integer) : boolean;
var
    i : integer;
begin
    for i := 1 to m-1 do
        if (queen[i] = queen[m]) { ######### ########### }
            Or (i+queen[i] = m+queen[m]) { ########## ######### }
            Or (i-queen[i] = m-queen[m]) { ########## ######### }
            then begin
                Check := False; Exit;
    end;
    Check := True;
end;

{ #########, ############## ####### }
procedure Backtrack(m : integer);
var
    i : integer;
begin
    if m > n then { ####### ####### }
        { WriteSolution }
    else
        for i := 1 to n do begin
            queen[m] := i;
            if Check(m) { m## ##### ## #### ########## }  then
                Backtrack(m+1);
        end;
end;

var
h1, m1, s1, hund1,
h2, m2, s2, hund2 : Word; { For GetTime}
time : longint;
begin
    Write('###### #####? '); Read(n);
    GetTime(h1,m1,s1,hund1);
    Backtrack(1);
    GetTime(h2,m2,s2,hund2);
    if h2 >= h1 then
       time := (hund2-hund1)+(s2-s1)*100+(m2-m1)*6000+(h2-h1)*360000
    else
       time := (hund2-hund1)+(s2-s1)*100+(m2-m1)*6000+(24+h2-h1)*360000;
    WriteLn(time);
end.
{ ######### ####### ###### ## n ###### #########
# ############### ########### # ########## ###### }
