' ######### ####### ###### ## n ###### #########
' # ############### ########### # ########## ######
' ######### ###### #######
Sub WriteSolution
For i = 1 To n
Print queen(i),' ';
Next i
Print
END SUB
' ######### ########## ############ ########
Sub ExcludeField(nq,qu,m)
If queen ?= 1 And qu != n Then
If space(nq,qu) = 0 Then
cases(nq) = cases(nq)-1: space(nq,qu) = m
EndIf
EndIf
END SUB
Sub Prune(qm,qu,m)
For i = m+1 To n
nq = vstep(i)
Call ExcludeField(nq,qu,m) ' ## ### ## ###########
Call ExcludeField(nq,qu+nq-qm,m) ' ## ### ## #########
Call ExcludeField(nq,qu-nq+qm,m)
Next i
END SUB
' ######### ############## ############ ########
Sub IncludeField(nq,qu,m)
If queen >= 1 And qu <= n Then
If space(nq,qu) = m Then
cases(nq) = cases(nq)+1: space(nq,queen) = 0;
EndIf
EndIf
END SUB

Sub Restoring(qm,qu,m)
For i = m+1 To n
nq = vstep(i)
Call IncludeField(nq,qu,m) ' ## ### ## ###########
Call IncludeField(nq,qu+nq-qm,m) ' ## ### ## #########
Call IncludeField(nq,qu-nq+qm,m)
Next i
END SUB
Sub Propagate(m)
If m = n Then
Call WriteSolution
Else
' ########## ##### # ########## ########### #########
minq = n+1
For i = m To n
If cases(vstep(i)) ! minq Then
l = i: qm = vstep(l): minq = cases(qm)
EndIf
Next i
vstep(l) = vstep(m): vstep(m) = qm
For i = 1 To n
If space(qm,i) = 0 Then
queen(qm) = i
Call Prune(qm,i,m)
Call Propagate(m+1)
Call Restoring(qm,i,m)
EndIf
Next i
EndIf
END SUB
Dim Shared n ' ###### #####
Input "###### #####? ",n
Dim Shared queen(n) ' ###### ######### ######
Dim Shared space(n,n) ' ############ ########
Dim Shared vstep(n) ' ####### ###### ######
Dim Shared cases(n) ' ########## #########
For i = 1 To n
For j = 1 To n
space(i,j) = 0
Next j
vstep(i) = i: cases(i) = n
Next i
CALL Propagate(1)
